Search.setIndex({"docnames": ["API reference", "API/Entities", "API/Entities/Boundaries", "API/Entities/FractureNetwork", "API/Entities/Fractures", "API/Plotting", "API/Statistic", "API/Statistic/NetworkFitter", "Glossary", "Introduction to fracture network analysis", "Quickstart", "Recommended resources", "Theory reference", "Theory/1. Fracture networks", "Theory/2. Topology", "Theory/3. Statistical modelling", "Tutorial reference", "Tutorials/1. Creating a FractureNetwork object", "Tutorials/2. Calculate topology of a FractureNetwork", "Tutorials/3. Plot a FracAbility entity", "index"], "filenames": ["API reference.rst", "API/Entities.rst", "API/Entities/Boundaries.rst", "API/Entities/FractureNetwork.rst", "API/Entities/Fractures.rst", "API/Plotting.rst", "API/Statistic.rst", "API/Statistic/NetworkFitter.rst", "Glossary.rst", "Introduction to fracture network analysis.rst", "Quickstart.rst", "Recommended resources.rst", "Theory reference.rst", "Theory/1. Fracture networks.rst", "Theory/2. Topology.rst", "Theory/3. Statistical modelling.rst", "Tutorial reference.rst", "Tutorials/1. Creating a FractureNetwork object.rst", "Tutorials/2. Calculate topology of a FractureNetwork.rst", "Tutorials/3. Plot a FracAbility entity.rst", "index.rst"], "titles": ["API Reference", "Entities", "Boundaries", "Fracture Networks", "Fractures", "Plotting options", "Statistic Operations", "NetworkFitter", "Glossary", "Introduction and scope of the FracAbility library.", "Quickstart for FracAbility", "Recommended resources", "Theory Reference", "Fracture networks", "Topology", "Statistical parametrization", "Tutorials reference", "Creating a FractureNetwork object", "Defining the topology", "Plotting", "Overview"], "terms": {"entiti": [0, 2, 3, 4, 20], "boundari": [0, 1, 3, 4, 8, 9, 10, 13, 14, 15], "fractur": [0, 1, 2, 7, 8, 9, 10, 11, 12, 14, 15, 20], "network": [0, 1, 2, 4, 7, 9, 11, 12, 14, 20], "plot": [0, 2, 3, 4, 10, 14, 16, 20], "option": [0, 20], "statist": [0, 7, 8, 9, 11, 12, 20], "oper": [0, 2, 3, 4, 7, 20], "networkfitt": [0, 6], "fracabl": [1, 2, 3, 4, 7, 20], "i": [1, 2, 3, 4, 8, 9, 10, 11, 13, 14, 15, 20], "base": [1, 2, 3, 4, 9, 11, 13], "access": 1, "manipul": 1, "data": [1, 3, 7, 9, 10, 11, 15], "enclos": 1, "object": [1, 2, 3, 4, 7, 8, 9, 10, 14, 16, 20], "defin": [1, 3, 10, 13, 14, 15, 16, 20], "each": [1, 2, 3, 4, 10, 14], "build": [1, 2, 4, 11, 13], "wai": [1, 3, 8, 10, 14], "properli": [1, 9], "modifi": [1, 2, 3, 4], "streamlin": 1, "input": [1, 2, 3, 4, 13], "repres": [1, 2, 3, 4, 14], "fracturenetwork": [1, 2, 3, 4, 16, 20], "combin": [1, 11], "us": [1, 2, 3, 4, 7, 9, 10, 11, 13, 14, 15, 20], "thi": [1, 2, 3, 4, 9, 10, 11, 13, 14, 15, 20], "orient": [1, 9], "approach": [1, 9, 13], "flexibl": [1, 10], "ensur": 1, "have": [1, 9, 10, 11, 13, 14], "share": 1, "custom": 1, "method": [1, 2, 3, 4, 7], "can": [1, 2, 3, 4, 9, 10, 11, 13, 14, 15, 20], "class": [2, 3, 4, 7], "gdf": [2, 3, 4], "geodatafram": [2, 3, 4], "none": [2, 3, 4, 7], "shp": [2, 3, 4, 10], "str": [2, 3, 4, 7], "group_n": [2, 3], "int": [2, 3, 4], "1": [2, 3, 4], "center_object": [2, 3, 4], "trans_cent": [2, 3, 4], "arrai": [2, 3, 4], "return_cent": [2, 3, 4], "bool": [2, 3, 4], "fals": [2, 3, 4], "inplac": [2, 3, 4], "true": [2, 3, 4, 10], "center": [2, 3, 4], "an": [2, 3, 4, 8, 10, 11, 13, 14, 15], "given": [2, 3, 4, 7, 9, 14, 15], "point": [2, 3, 4, 13], "If": [2, 3, 4, 10], "specifi": [2, 3, 4], "move": [2, 3, 4, 13], "origin": [2, 3, 4, 13], "0": [2, 3, 4], "paramet": [2, 3, 4, 7, 9, 11, 12, 13], "obj": [2, 3, 4, 7], "A": [2, 3, 4, 9, 11, 14, 15, 20], "which": [2, 3, 4, 8, 9, 10, 11, 13, 14], "translat": [2, 3, 4, 15], "flag": [2, 3, 4], "return": [2, 3, 4, 7], "overwrit": [2, 3, 4], "creat": [2, 3, 4, 13, 16, 20], "new": [2, 3, 4, 10], "instanc": [2, 3, 4], "output": [2, 3, 4], "copy_obj": [2, 3, 4], "copi": [2, 3, 4], "preserv": [2, 3, 4, 8], "properti": [2, 3, 4, 7, 8, 9, 13], "centroid": [2, 3, 4], "ndarrai": [2, 3, 4], "dissolv": [2, 3, 4], "aggreg": [2, 3, 4], "shape": [2, 3, 4], "singl": [2, 3, 4], "1d": [2, 3, 4], "numpi": [2, 3, 4], "cr": [2, 3, 4], "name": [2, 3, 4, 7, 20], "coordin": [2, 3, 4], "system": [2, 3, 4], "string": [2, 3, 4], "entity_df": [2, 3, 4, 7, 10], "geopanda": [2, 3, 4, 10], "datafram": [2, 3, 4, 7, 10], "set": [2, 3, 4, 7, 8, 13], "getter": [2, 3, 4], "setter": [2, 3, 4], "type": [2, 3, 4, 10, 14, 15], "note": [2, 3, 4], "when": [2, 3, 4, 11, 15], "conform": [2, 3, 4], "assign": [2, 3, 4], "structur": [2, 3, 4, 9, 12], "get_copi": [2, 3, 4], "deep": [2, 3, 4], "matplot": [2, 3, 4], "matplotlib": [2, 3, 4, 10, 20], "backend": [2, 4], "e": [2, 3, 4, 9, 11, 13, 14], "network_object": [2, 3, 4], "graph": [2, 3, 4, 11, 12], "networkx": [2, 3, 4], "vtk": [2, 3, 4, 10, 20], "so": [2, 4, 10, 11, 14], "df": [2, 3, 4, 7], "pyvista": [2, 4, 10], "get": [2, 4, 7], "appli": [2, 4, 9, 15], "fly": [2, 4], "save_csv": [2, 3, 4], "path": [2, 3, 4], "sep": [2, 3, 4], "index": [2, 3, 4, 20], "save": [2, 3, 4], "csv": [2, 3, 4], "param": [2, 3, 4, 7], "save_shp": [2, 3, 4], "vtk_object": [2, 3, 4, 10], "polydata": [2, 3, 4], "gener": [2, 4, 9, 13, 15], "dataset": [2, 3, 4, 9, 10], "sourc": [2, 4], "cast": [2, 4], "vtkplot": [2, 3, 4], "ar": [3, 8, 10, 11, 13, 14, 15, 20], "one": [3, 13, 14], "more": [3, 9, 13, 14], "node": [3, 10, 12, 13, 20], "all": [3, 10, 13], "differ": [3, 4, 8, 9, 10, 13, 14], "column": 3, "two": [3, 11, 13, 14], "depend": 3, "how": [3, 10, 14], "file": 3, "add_fractur": [3, 10], "add_boundari": [3, 10], "add_nod": 3, "empti": 3, "2": [3, 9], "directli": 3, "fed": 3, "instanti": 3, "In": [3, 9, 10, 14, 15], "case": [3, 15], "must": [3, 15], "indic": [3, 14], "geometri": 3, "activate_boundari": 3, "list": [3, 7, 11], "activ": [3, 4], "provid": [3, 9, 11, 13, 15], "group": [3, 13], "activate_fractur": 3, "set_n": [3, 4], "activate_nod": 3, "node_typ": 3, "add": [3, 4], "compon": [3, 8, 13], "ad": 3, "The": [3, 9, 10, 11, 13, 14, 15, 20], "present": [3, 13], "alreadi": 3, "overwritten": 3, "append": 3, "fracture_set": 3, "boundary_object": 3, "group_numb": 3, "number": [3, 10, 11, 14], "deactivate_boundari": 3, "deactiv": 3, "deactivate_fractur": 3, "deactivate_nod": 3, "fracture_network_to_components_df": 3, "whole": [3, 14], "fracture_object": 3, "is_group_act": 3, "check": [3, 11], "valu": 3, "test": [3, 7, 11, 20], "is_set_act": 3, "is_type_act": 3, "markers": 3, "5": 3, "linewidth": [3, 4], "color": [3, 4, 10], "black": 3, "blue": 3, "color_set": [3, 4], "return_ax": 3, "represent": [3, 8, 14], "nodes_object": 3, "plot_ternari": 3, "ternari": [3, 14, 20], "diagram": [3, 4, 20], "include_nod": 3, "vtkpolydata": 3, "control": [3, 9, 13], "includ": [3, 10, 11], "white": [3, 4, 10], "return_plot": [3, 4], "rose": [4, 20], "display_properti": 4, "fit": [7, 9, 11, 15, 20], "best_fit": 7, "seri": 7, "best": 7, "record": 7, "find_best_distribut": 7, "distribution_list": 7, "find": [7, 11], "distribut": [7, 9, 11, 13, 15, 20], "bic": 7, "rank": 7, "distribution_nam": 7, "scipi": 7, "avail": [7, 10, 11, 20], "fit_record": 7, "sort": 7, "get_fitted_distribut": 7, "networkdistribut": 7, "get_fitted_distribution_list": 7, "fot": 7, "get_fitted_paramet": 7, "tupl": 7, "get_fitted_parameters_list": 7, "comput": [7, 11], "": [7, 11, 20], "panda": 7, "net_data": 7, "networkdata": 7, "rejected_fit": 7, "without": [7, 8], "digit": [8, 9, 11, 20], "outcrop": [8, 9, 11, 13, 14, 20], "model": [8, 9, 11, 13, 15, 20], "dom": [8, 9], "qualit": 8, "three": [8, 13, 15], "dimension": [8, 11], "suitabl": 8, "rock": [8, 9, 13, 20], "interpret": [8, 10, 13, 15], "area": [8, 9, 11, 13], "possibl": [8, 9, 14], "carri": [8, 9, 13], "out": [8, 9, 13], "void": [8, 13, 15], "intern": [8, 13, 15], "imposs": 8, "surviv": [8, 9, 11, 15], "analysi": [8, 9, 11, 15, 20], "techniqu": [8, 9, 15], "correct": [8, 9, 15], "left": [8, 15], "right": [8, 9, 15], "interv": [8, 15], "censor": [8, 9, 11, 12], "topologi": [8, 9, 11, 12, 16, 20], "studi": [8, 9, 11], "through": [8, 11], "deform": 8, "tear": 8, "rip": 8, "mallet": 8, "2002": [8, 11, 14], "describ": [8, 14], "part": 8, "connect": [8, 10, 11, 14], "recent": [9, 10], "solid": 9, "framework": 9, "collect": [9, 11], "larg": [9, 11], "quantit": 9, "from": [9, 10, 11, 13, 14, 15], "extract": [9, 13], "view": [9, 10], "natur": [9, 13, 14], "section": [9, 11], "volum": [9, 13], "fact": 9, "big": [9, 10], "advantag": 9, "lie": 9, "mesoscal": 9, "inform": [9, 14, 15], "while": [9, 14], "strong": 9, "field": 9, "On": 9, "flip": 9, "side": 9, "need": [9, 10], "both": 9, "we": [9, 10, 11, 13, 15], "between": [9, 10, 13, 14], "mani": [9, 10, 13, 14], "optim": [9, 11], "relat": [9, 14], "same": [9, 13], "extrapol": [9, 14], "constrain": 9, "With": [9, 14], "focu": 9, "investig": 9, "length": [9, 11, 12, 14], "2d": [9, 10], "5d": 9, "map": 9, "obtain": 9, "becaus": 9, "complex": [9, 14], "expos": [9, 13], "parametr": [9, 12], "sometim": [9, 14], "challeng": 9, "cover": 9, "debri": 9, "veget": 9, "patch": 9, "simpli": 9, "outer": 9, "introduc": [9, 15], "bia": [9, 15], "often": [9, 15], "lead": 9, "underestim": [9, 15], "intersect": [9, 10, 13], "surfac": 9, "classic": 9, "issu": 9, "resolv": 9, "estim": [9, 11, 15], "empir": [9, 20], "formula": 9, "precis": 9, "bind": 9, "hypothesi": 9, "typic": [9, 10], "disciplin": 9, "biologi": 9, "engin": [9, 11, 15], "follow": [9, 11, 13, 15], "chapter": 9, "briefli": 9, "concept": 9, "them": [9, 14], "also": [9, 10, 11, 13, 14], "topolog": [9, 10, 11, 14], "refer": [9, 20], "you": 10, "python": [10, 20], "first": 10, "3": 10, "id": 10, "interact": 10, "code": 10, "There": [10, 13], "good": [10, 11], "pycharm": 10, "spyder": 10, "jupyt": 10, "onc": 10, "time": [10, 11, 15], "open": 10, "your": [10, 11], "command": 10, "prompt": 10, "pip": 10, "To": 10, "previou": 10, "reliabl": [10, 11, 15, 20], "most": [10, 11, 13], "version": 10, "kei": 10, "featur": [10, 14, 20], "function": [10, 15], "design": 10, "modular": 10, "allow": 10, "workflow": 10, "tool": [10, 11, 20], "quickli": 10, "illustr": 10, "its": [10, 14], "import": [10, 13, 20], "gpd": 10, "pv": 10, "n_path": 10, "fracture_network": 10, "b_path": 10, "interpretation_boundary_laghettosalza": 10, "frac_gpd": 10, "read_fil": 10, "bound_gpd": 10, "fracture_net": 10, "These": [10, 13, 20], "step": 10, "compos": [10, 14], "now": 10, "identifi": [10, 13, 14], "common": 10, "segment": [10, 14], "done": 10, "coupl": 10, "specif": 10, "geometric_oper": 10, "tidy_intersect": 10, "clean_oper": 10, "connect_dot": 10, "topology_oper": 10, "nodes_conn": 10, "tidi": 10, "shapefil": [10, 20], "merg": 10, "overlap": 10, "calcul": [10, 11, 20], "adjac": 10, "per": [10, 14], "few": 10, "line": [10, 11, 14], "clean": 10, "f": 10, "b": [10, 11], "databas": 10, "3d": [10, 13], "window": 10, "recommend": [10, 20], "print": 10, "set_active_scalar": 10, "class_id": 10, "plotter": 10, "add_mesh": 10, "render_points_as_spher": 10, "point_siz": 10, "10": 10, "view_xi": 10, "show": 10, "thing": 11, "found": 11, "subject": 11, "librari": 11, "practic": 11, "nonparametr": 11, "1999": 11, "w": 11, "j": 11, "conov": 11, "2011": 11, "r": 11, "g": [11, 14], "miller": 11, "analys": [11, 20], "clinic": 11, "trial": 11, "observ": [11, 13, 15], "2004": 11, "marubini": 11, "m": 11, "valsecchi": 11, "theori": [11, 15], "2017": 11, "diestel": 11, "chi": 11, "squar": 11, "nikulin": 11, "networkgt": 11, "gi": 11, "geometr": 11, "2018": 11, "nyberg": 11, "c": 11, "nixon": 11, "character": [11, 13], "2015": 11, "d": 11, "sanderson": 11, "spatial": [11, 14], "correl": 11, "t": [11, 14], "manzocchi": [11, 14], "damag": 11, "zone": 11, "scan": 11, "km": 11, "scale": 11, "qala": 11, "fault": 11, "gozo": 11, "2020": 11, "martinelli": 11, "et": 11, "al": 11, "wood": 11, "fibr": 11, "em": 11, "algorithm": [11, 13], "2006": 11, "svensson": 11, "packag": 11, "here": 11, "doe": 11, "impli": 11, "my": 11, "endors": 11, "onli": 11, "intend": 11, "give": [11, 14, 15], "reader": 11, "understand": [11, 13], "broad": 11, "rang": 11, "It": 11, "difficult": 11, "comprehens": 11, "sinc": [11, 15], "develop": 11, "proprietari": 11, "rare": 11, "acknowledg": 11, "exist": 11, "ani": 11, "other": [11, 14], "than": [11, 13], "own": 11, "paid": 11, "due": 11, "high": 11, "cost": 11, "comment": 11, "pure": 11, "content": 11, "websit": 11, "analyt": 11, "toolkit": 11, "run": 11, "googl": 11, "app": 11, "weibull_2p": 11, "distributom": 11, "pdf": 11, "cdf": [11, 20], "probabl": 11, "easili": 11, "chang": 11, "slider": 11, "quantil": 11, "similar": 11, "below": [11, 14, 15], "abov": 11, "mainten": 11, "replac": 11, "polici": 11, "under": 11, "kijima": 11, "imperfect": 11, "repair": 11, "wolfram": 11, "alpha": 11, "amaz": 11, "knowledg": 11, "great": 11, "classif": 12, "essenti": [13, 15], "hydraul": 13, "mass": 13, "research": 13, "exploit": 13, "water": 13, "hydrotherm": 13, "fluid": 13, "ga": 13, "reservoir": 13, "carbon": 13, "sequestr": 13, "hydrogen": 13, "storag": 13, "heavili": 13, "reli": 13, "space": [13, 15], "achiev": 13, "discret": 13, "dfn": [13, 15], "stochast": 13, "softwar": [13, 20], "petrel": 13, "fracman": 13, "dfnwork": 13, "drive": 13, "summar": 13, "tabl": 13, "summari": 13, "distinct": 13, "where": 13, "subdivid": 13, "main": [13, 15, 20], "subdivis": 13, "simpl": 13, "pertain": 13, "unsurprisingli": 13, "discontinu": 13, "further": 13, "divid": 13, "genet": [13, 14], "process": [13, 14], "final": 13, "limit": [13, 15], "impos": 13, "delimit": 13, "measur": [13, 15], "cannot": 13, "analis": 14, "abstract": 14, "even": 14, "isol": 14, "focuss": 14, "relationship": 14, "interest": 14, "descript": 14, "simplifi": 14, "edg": 14, "vertic": 14, "v": 14, "mean": 14, "degre": 14, "classifi": 14, "accordingli": 14, "exampl": [14, 20], "small": 14, "partial": [14, 15], "conserv": 14, "help": [14, 20], "comparison": 14, "higher": 14, "dimens": 14, "complet": 14, "disregard": 14, "four": 14, "been": 14, "termin": [14, 15], "y": [14, 20], "anoth": 14, "x": [14, 20], "cross": 14, "u": [14, 20], "schemat": [14, 15], "For": [14, 15], "cell": 14, "highlight": 14, "correspond": 14, "geolog": 14, "bound": 14, "presenc": 14, "cut": [14, 15], "hand": 14, "rel": 14, "chronologi": 14, "joint": 14, "abut": 14, "older": 14, "younger": 14, "proport": 14, "opposit": 14, "domin": 14, "principl": [14, 15], "graphic": 14, "red": 14, "dot": 14, "contour": 14, "averag": 14, "deriv": 14, "equat": 14, "a6": 14, "construct": 15, "guid": 15, "creation": [15, 20], "synthet": 15, "immedi": 15, "problem": 15, "aris": 15, "thu": 15, "root": 15, "medic": 15, "biolog": 15, "sphere": 15, "continu": 15, "variabl": 15, "our": 15, "maintain": 15, "still": 15, "definit": 15, "start": 15, "insid": 15, "outsid": 15, "hole": 15, "try": 15, "eventu": 15, "assur": 15, "depth": 15, "explan": 15, "page": 15, "By": 15, "toolbox": 20, "support": 20, "rapid": 20, "identif": 20, "backbon": 20, "sf": 20, "recal": 20, "inspir": 20, "project": 20, "instal": 20, "upgrad": 20, "quick": 20, "introduct": 20, "scope": 20, "resourc": 20, "textbook": 20, "articl": 20, "onlin": 20, "deploy": 20, "github": 20, "citat": 20, "licens": 20, "commun": 20}, "objects": {"fracability.Entities": [[2, 0, 1, "", "Boundary"], [3, 0, 1, "", "FractureNetwork"], [4, 0, 1, "", "Fractures"]], "fracability.Entities.Boundary": [[2, 1, 1, "", "center_object"], [2, 2, 1, "", "centroid"], [2, 2, 1, "", "crs"], [2, 2, 1, "", "entity_df"], [2, 2, 1, "", "get_copy"], [2, 1, 1, "", "matplot"], [2, 2, 1, "", "name"], [2, 2, 1, "", "network_object"], [2, 1, 1, "", "save_csv"], [2, 1, 1, "", "save_shp"], [2, 2, 1, "", "vtk_object"], [2, 1, 1, "", "vtkplot"]], "fracability.Entities.FractureNetwork": [[3, 1, 1, "", "activate_boundaries"], [3, 1, 1, "", "activate_fractures"], [3, 1, 1, "", "activate_nodes"], [3, 1, 1, "", "add_boundaries"], [3, 1, 1, "", "add_fractures"], [3, 1, 1, "", "add_nodes"], [3, 2, 1, "", "boundaries"], [3, 1, 1, "", "boundary_object"], [3, 1, 1, "", "center_object"], [3, 2, 1, "", "centroid"], [3, 2, 1, "", "crs"], [3, 1, 1, "", "deactivate_boundaries"], [3, 1, 1, "", "deactivate_fractures"], [3, 1, 1, "", "deactivate_nodes"], [3, 2, 1, "", "entity_df"], [3, 1, 1, "", "fracture_network_to_components_df"], [3, 1, 1, "", "fracture_object"], [3, 2, 1, "", "fractures"], [3, 2, 1, "", "get_copy"], [3, 1, 1, "", "is_group_active"], [3, 1, 1, "", "is_set_active"], [3, 1, 1, "", "is_type_active"], [3, 1, 1, "", "matplot"], [3, 2, 1, "", "name"], [3, 2, 1, "", "network_object"], [3, 2, 1, "", "nodes"], [3, 1, 1, "", "nodes_object"], [3, 1, 1, "", "plot_ternary"], [3, 1, 1, "", "save_csv"], [3, 1, 1, "", "save_shp"], [3, 1, 1, "", "vtk_object"], [3, 1, 1, "", "vtkplot"]], "fracability.Entities.Fractures": [[4, 1, 1, "", "center_object"], [4, 2, 1, "", "centroid"], [4, 2, 1, "", "crs"], [4, 2, 1, "", "entity_df"], [4, 2, 1, "", "get_copy"], [4, 1, 1, "", "matplot"], [4, 2, 1, "", "name"], [4, 2, 1, "", "network_object"], [4, 1, 1, "", "save_csv"], [4, 1, 1, "", "save_shp"], [4, 2, 1, "", "vtk_object"], [4, 1, 1, "", "vtkplot"]], "fracability.operations.Statistics": [[7, 0, 1, "", "NetworkFitter"]], "fracability.operations.Statistics.NetworkFitter": [[7, 1, 1, "", "best_fit"], [7, 1, 1, "", "find_best_distribution"], [7, 1, 1, "", "fit"], [7, 2, 1, "", "fit_records"], [7, 1, 1, "", "get_fitted_distribution"], [7, 1, 1, "", "get_fitted_distribution_list"], [7, 1, 1, "", "get_fitted_parameters"], [7, 1, 1, "", "get_fitted_parameters_list"], [7, 2, 1, "", "net_data"], [7, 1, 1, "", "rejected_fit"]]}, "objtypes": {"0": "py:class", "1": "py:method", "2": "py:property"}, "objnames": {"0": ["py", "class", "Python class"], "1": ["py", "method", "Python method"], "2": ["py", "property", "Python property"]}, "titleterms": {"api": [0, 20], "refer": [0, 12, 16], "entiti": [1, 10], "boundari": 2, "fractur": [3, 4, 13], "network": [3, 10, 13], "plot": [5, 19], "option": 5, "statist": [6, 10, 15], "oper": 6, "networkfitt": 7, "glossari": [8, 20], "introduct": 9, "scope": 9, "fracabl": [9, 10], "librari": [9, 20], "theori": [9, 12, 14, 20], "index": 9, "quickstart": [10, 20], "instal": 10, "upgrad": 10, "A": 10, "quick": 10, "exampl": 10, "creat": [10, 17], "fracturenetwork": [10, 17], "visual": 10, "analyz": 10, "length": [10, 15], "recommend": 11, "resourc": 11, "textbook": 11, "articl": 11, "softwar": 11, "onlin": 11, "structur": 13, "topologi": [14, 18], "graph": 14, "node": 14, "classif": 14, "class": 14, "parametr": 15, "censor": 15, "paramet": 15, "tutori": [16, 20], "object": 17, "defin": 18, "overview": 20, "document": 20, "content": 20, "statu": 20, "inform": 20}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 8, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx": 57}, "alltitles": {"API Reference": [[0, "api-reference"]], "Entities": [[1, "entities"]], "Boundaries": [[2, "boundaries"]], "Fracture Networks": [[3, "fracture-networks"]], "Fractures": [[4, "fractures"]], "Plotting options": [[5, "plotting-options"]], "Statistic Operations": [[6, "statistic-operations"]], "NetworkFitter": [[7, "networkfitter"]], "Glossary": [[8, "glossary"], [20, "glossary"]], "Introduction and scope of the FracAbility library.": [[9, "introduction-and-scope-of-the-fracability-library"]], "Theory index": [[9, "theory-index"]], "Quickstart for FracAbility": [[10, "quickstart-for-fracability"]], "Installation and upgrading": [[10, "installation-and-upgrading"]], "A quick example": [[10, "a-quick-example"]], "Create a FractureNetwork entity": [[10, "create-a-fracturenetwork-entity"]], "Visualize the network": [[10, "visualize-the-network"]], "Analyze length statistics": [[10, "analyze-length-statistics"]], "Recommended resources": [[11, "recommended-resources"]], "Textbooks": [[11, "textbooks"]], "Articles": [[11, "articles"]], "Software": [[11, "software"]], "Online resources": [[11, "online-resources"]], "Theory Reference": [[12, "theory-reference"]], "Fracture networks": [[13, "fracture-networks"]], "Structure of a fracture network": [[13, "structure-of-a-fracture-network"]], "Topology": [[14, "topology"]], "Graph theory and node classification": [[14, "graph-theory-and-node-classification"]], "Node classes": [[14, "node-classes"]], "Statistical parametrization": [[15, "statistical-parametrization"]], "Censoring": [[15, "censoring"]], "Length parameter": [[15, "length-parameter"]], "Tutorials reference": [[16, "tutorials-reference"]], "Creating a FractureNetwork object": [[17, "creating-a-fracturenetwork-object"]], "Defining the topology": [[18, "defining-the-topology"]], "Plotting": [[19, "plotting"]], "Overview": [[20, "overview"]], "Documentation contents": [[20, "documentation-contents"]], "Quickstart & Theory": [[20, "quickstart-theory"]], "Tutorials": [[20, "tutorials"]], "API": [[20, "api"]], "Library status information": [[20, "library-status-information"]]}, "indexentries": {"boundary (class in fracability.entities)": [[2, "fracability.Entities.Boundary"]], "center_object() (fracability.entities.boundary method)": [[2, "fracability.Entities.Boundary.center_object"]], "centroid (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.centroid"]], "crs (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.crs"]], "entity_df (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.entity_df"]], "get_copy (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.get_copy"]], "matplot() (fracability.entities.boundary method)": [[2, "fracability.Entities.Boundary.matplot"]], "name (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.name"]], "network_object (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.network_object"]], "save_csv() (fracability.entities.boundary method)": [[2, "fracability.Entities.Boundary.save_csv"]], "save_shp() (fracability.entities.boundary method)": [[2, "fracability.Entities.Boundary.save_shp"]], "vtk_object (fracability.entities.boundary property)": [[2, "fracability.Entities.Boundary.vtk_object"]], "vtkplot() (fracability.entities.boundary method)": [[2, "fracability.Entities.Boundary.vtkplot"]], "fracturenetwork (class in fracability.entities)": [[3, "fracability.Entities.FractureNetwork"]], "activate_boundaries() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.activate_boundaries"]], "activate_fractures() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.activate_fractures"]], "activate_nodes() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.activate_nodes"]], "add_boundaries() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.add_boundaries"]], "add_fractures() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.add_fractures"]], "add_nodes() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.add_nodes"]], "boundaries (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.boundaries"]], "boundary_object() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.boundary_object"]], "center_object() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.center_object"]], "centroid (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.centroid"]], "crs (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.crs"]], "deactivate_boundaries() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.deactivate_boundaries"]], "deactivate_fractures() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.deactivate_fractures"]], "deactivate_nodes() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.deactivate_nodes"]], "entity_df (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.entity_df"]], "fracture_network_to_components_df() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.fracture_network_to_components_df"]], "fracture_object() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.fracture_object"]], "fractures (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.fractures"]], "get_copy (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.get_copy"]], "is_group_active() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.is_group_active"]], "is_set_active() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.is_set_active"]], "is_type_active() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.is_type_active"]], "matplot() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.matplot"]], "name (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.name"]], "network_object (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.network_object"]], "nodes (fracability.entities.fracturenetwork property)": [[3, "fracability.Entities.FractureNetwork.nodes"]], "nodes_object() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.nodes_object"]], "plot_ternary() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.plot_ternary"]], "save_csv() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.save_csv"]], "save_shp() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.save_shp"]], "vtk_object() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.vtk_object"]], "vtkplot() (fracability.entities.fracturenetwork method)": [[3, "fracability.Entities.FractureNetwork.vtkplot"]], "fractures (class in fracability.entities)": [[4, "fracability.Entities.Fractures"]], "center_object() (fracability.entities.fractures method)": [[4, "fracability.Entities.Fractures.center_object"]], "centroid (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.centroid"]], "crs (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.crs"]], "entity_df (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.entity_df"]], "get_copy (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.get_copy"]], "matplot() (fracability.entities.fractures method)": [[4, "fracability.Entities.Fractures.matplot"]], "name (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.name"]], "network_object (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.network_object"]], "save_csv() (fracability.entities.fractures method)": [[4, "fracability.Entities.Fractures.save_csv"]], "save_shp() (fracability.entities.fractures method)": [[4, "fracability.Entities.Fractures.save_shp"]], "vtk_object (fracability.entities.fractures property)": [[4, "fracability.Entities.Fractures.vtk_object"]], "vtkplot() (fracability.entities.fractures method)": [[4, "fracability.Entities.Fractures.vtkplot"]], "networkfitter (class in fracability.operations.statistics)": [[7, "fracability.operations.Statistics.NetworkFitter"]], "best_fit() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.best_fit"]], "find_best_distribution() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.find_best_distribution"]], "fit() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.fit"]], "fit_records (fracability.operations.statistics.networkfitter property)": [[7, "fracability.operations.Statistics.NetworkFitter.fit_records"]], "get_fitted_distribution() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.get_fitted_distribution"]], "get_fitted_distribution_list() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.get_fitted_distribution_list"]], "get_fitted_parameters() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.get_fitted_parameters"]], "get_fitted_parameters_list() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.get_fitted_parameters_list"]], "net_data (fracability.operations.statistics.networkfitter property)": [[7, "fracability.operations.Statistics.NetworkFitter.net_data"]], "rejected_fit() (fracability.operations.statistics.networkfitter method)": [[7, "fracability.operations.Statistics.NetworkFitter.rejected_fit"]], "digital outcrop models (doms)": [[8, "term-Digital-Outcrop-Models-DOMs"]], "interpretational boundaries": [[8, "term-Interpretational-boundaries"]], "interpretational voids": [[8, "term-Interpretational-voids"]], "survival analysis": [[8, "term-Survival-analysis"]], "topology": [[8, "term-Topology"]]}})